/*
*  nntperrdlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <inifiles.hpp>

#include "nntperrdlgs.h"
#include "global.h"
#include "utility.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNntpErrDlg *NntpErrDlg;
//---------------------------------------------------------------------------

void __fastcall ShowNNTPError(TForm *Owner, TStrings *ErrorText)
{
   TNntpErrDlg *errdlg = new TNntpErrDlg(Owner);
   errdlg->ErrorMsg->Lines->AddStrings(ErrorText);
   errdlg->ShowModal();
   delete errdlg;
}
//---------------------------------------------------------------------------

__fastcall TNntpErrDlg::TNntpErrDlg(TComponent* Owner)
	: TForm(Owner)
{
   ErrorMsg->Clear();
   TIniFile *ini = new TIniFile(AppIni());
   LoadWindowPosition(this, "smtpdlg", ini);
   //orgwin = IntToStr(Width)+IntToStr(Height);
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(ErrorMsg->Font, ini->ReadString("settings", "editorfont", OptsDefEditorFont));
   delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TNntpErrDlg::FormShow(TObject *Sender)
{
   ErrorMsg->SelStart = ErrorMsg->Text.Length();
   ErrorMsg->Perform(EM_SCROLLCARET, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TNntpErrDlg::Copy1Click(TObject *Sender)
{
   ErrorMsg->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TNntpErrDlg::Selectall1Click(TObject *Sender)
{
   ErrorMsg->SelectAll();	
}
//---------------------------------------------------------------------------

