/*
*  qsa.cpp
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library),
*  containing parts covered by the terms of CodeGear's license, the licensors
*  of QuickSilver AAM grant you additional permission to convey the
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("mainwins.cpp", QSAMainWin);
USEFORM("paramsdlgs.cpp", ParamsDlg);
USEFORM("pgpdpassdlgs.cpp", PGPDPassDlg);
USEFORM("gnupg.cpp", GPGerrDlg);
USEFORM("proxymandlgs.cpp", ProxyManDlg);
USEFORM("proxydlgs.cpp", ProxyDlg);
USEFORM("nntphostdlgs.cpp", NNTPHostDlg);
USEFORM("nntpmandlgs.cpp", NNTPManDlg);
USEFORM("pgpdlgs.cpp", PgpDlg);
USEFORM("msgwins.cpp", MsgWin);
USEFORM("optionsdlgs.cpp", OptionsDlg);
USEFORM("subjectsmandlgs.cpp", SubjectsManDlg);
USEFORM("subjectsdlgs2.cpp", SubjectsDlg);
USEFORM("sampledlgs.cpp", SampleDlg);
USEFORM("logdlgs.cpp", LogDlg);
USEFORM("cancelnntpdlgs.cpp", CancelNntpDlg);
USEFORM("nntperrdlgs.cpp", NntpErrDlg);
USEFORM("dsadlgs.cpp", DSADlg);
USEFORM("secdbs.cpp", DBSecModeDlg);
USEFORM("blenddlgs.cpp", BlendDlg);
USEFORM("keyringdlgs.cpp", KeyringDlg);
USEFORM("welcomedlgs.cpp", WelcomeDlg);
USEFORM("nymsrvmandlgs.cpp", NymSrvManDlg);
USEFORM("nymserverdlgs.cpp", NymserverDlg);
USEFORM("sigfaileddlgs.cpp", SigFailedDlg);
USEFORM("pgpdpassdlgs2.cpp", PGPDPassDlg2);
USEFORM("cfgmsgdlgs.cpp", CfgMsgDlg);
USEFORM("badcommadlgs.cpp", BadCommaDlg);
USEFORM("noparadlgs.cpp", NoParaDlg);
USEFORM("NNTPMods2.cpp", NNTPMod2);
USEFORM("nymoptsdlgs.cpp", NymOptionsDlg);
//---------------------------------------------------------------------------
#include "global.h"
//---------------------------------------------------------------------------

bool __fastcall CheckStartupInfoMinimized()
{
   STARTUPINFO StartupInfo;
   GetStartupInfo(&StartupInfo);
   if (StartupInfo.wShowWindow == SW_SHOWMINIMIZED || StartupInfo.wShowWindow == SW_SHOWMINNOACTIVE)
   {
	  MsgBox(NULL,
		 "I see you've started QSA from a shortcut, with the window minimized.  \n"
		 "Sorry, that won't work with QSA. In order to do that, rather than setting   \n"
		 "minimized in the shortcut Run field, add the command line switch,   \n"
		 "-minimized, to the shortcut Target field. Like this:\n\n"
		 "Target:  "+AppDir()+"qsa.exe -minimized",
		  MT_INFO, MB_OK);
	  return true;
   }
   return false;
}
//---------------------------------------------------------------------------

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR CmdLine, int)
{
	WM_QSAMESSAGE = RegisterWindowMessage("WMQSAMESSAGE");
	WM_QSLMESSAGE = RegisterWindowMessage("WMQSLMESSAGE");
	WM_QS2MESSAGE = RegisterWindowMessage("WMQS2MESSAGE");
	WM_TASKBARCREATED = RegisterWindowMessage("TaskbarCreated");
	HANDLE hWnd, QSASubMutex = CreateMutex(NULL, FALSE, "QSAMainWin");
	if(GetLastError() == ERROR_ALREADY_EXISTS)
	{
		if ((hWnd = FindWindow("TQSAMainWin", NULL)) > 0)
		{
			PostMessage(hWnd, WM_QSAMESSAGE, BRINGTOFRONT, 0);
			return 0;
		}
	}

	if (CheckStartupInfoMinimized())
	   return 0;

	try
	{
		Application->Initialize();
		Application->Title = "QuickSilver AAM";
		SetApplicationMainFormOnTaskBar(Application, true);
		Application->CreateForm(__classid(TQSAMainWin), &QSAMainWin);
		Application->Run();
	}

	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}

	//ReleaseMutex(QSASubMutex);
	return 0;
}
//---------------------------------------------------------------------------
